import * as React from 'react';
/**
 * Generic name to any dictionary.
 */
export declare type GenericDictionary = Record<string, any>;
/**
 * Class dictionary.
 */
export declare type ClassDictionary = Record<string, string>;
export interface ComponentProps extends GenericDictionary {
    as?: React.ElementType;
    ref?: React.Ref<any>;
    className?: string;
}
export declare type ShorthandRenderFunction<TProps> = (Component: React.ElementType<TProps>, props: TProps) => React.ReactNode;
export declare type ShorthandProps<TProps extends ComponentProps = {}> = React.ReactChild | React.ReactNodeArray | React.ReactPortal | boolean | number | null | undefined | (TProps & ComponentProps & {
    children?: TProps['children'] | ShorthandRenderFunction<TProps>;
});
